import telebot
import json
import requests
import threading
import os
from datetime import datetime, timedelta

ADMIN_ID = "6305867785"
TOKEN = "7354538082:AAExfyLTNkykBamXVztlHuyk_21Z-ShP2FQ"
DATA_FILE = "data.json"
MEMBERS_FILE = "members.json"

bot = telebot.TeleBot(TOKEN)

# Nạp danh sách thành viên từ file members.json
def load_members():
    try:
        with open(MEMBERS_FILE, "r") as f:
            data = json.load(f)
            if isinstance(data, dict):
                return data
            else:
                return {}
    except (FileNotFoundError, json.JSONDecodeError):
        return {}

def save_members(members):
    with open(MEMBERS_FILE, "w") as f:
        json.dump(members, f, indent=4)

# Kiểm tra người dùng có phải thành viên và có hạn sử dụng hợp lệ không
def is_member(user_id):
    members = load_members()
    
    # Nếu người dùng là admin, luôn luôn trả về True
    if user_id == ADMIN_ID:
        return True
    
    # Kiểm tra nếu người dùng có trong danh sách thành viên và hạn sử dụng còn hiệu lực
    user_data = members.get(user_id)
    if user_data:
        expire_date = user_data.get("expire_date")
        if expire_date:
            # So sánh hạn sử dụng với ngày hiện tại
            if datetime.strptime(expire_date, "%Y-%m-%d") >= datetime.now():
                return True  # Nếu hạn sử dụng chưa hết, người dùng vẫn có quyền sử dụng bot
    return False  # Người dùng không có trong danh sách thành viên hoặc hạn sử dụng đã hết
def is_member(user_id):
    members = load_members()
    
    # Nếu người dùng là admin, luôn luôn trả về True
    if user_id == ADMIN_ID:
        return True
    
    # Kiểm tra nếu người dùng có trong danh sách thành viên và hạn sử dụng còn hiệu lực
    user_data = members.get(user_id)
    if user_data:
        expire_date = user_data.get("expire_date")
        if expire_date:
            # Nếu ngày hết hạn là 0, coi như người dùng đã hết hạn
            if expire_date == "0":
                return False
            
            # Nếu không phải 0, tiến hành kiểm tra ngày hết hạn
            try:
                if datetime.strptime(expire_date, "%Y-%m-%d") >= datetime.now():
                    return True  # Nếu hạn sử dụng chưa hết, người dùng vẫn có quyền sử dụng bot
            except ValueError:
                return False  # Nếu không thể chuyển đổi được ngày, coi như không hợp lệ
    return False  # Người dùng không có trong danh sách thành viên hoặc hạn sử dụng đã hết

def load_data():
    try:
        with open(DATA_FILE, "r") as f:
            return json.load(f)
    except (FileNotFoundError, json.JSONDecodeError):
        return {}

def save_data(data):
    with open(DATA_FILE, "w") as f:
        json.dump(data, f, indent=4)
data = load_data()

# Check if a Facebook link is live
def check_live(fb_id):
    try:
        rq = requests.post('https://id.traodoisub.com/api.php', data={"link": fb_id}).json()
        return 'success' in rq
    except requests.exceptions.RequestException:
        return False  # Trường hợp có lỗi trong quá trình yêu cầu HTTP
# Kiểm tra link trong một thread riêng biệt để không làm gián đoạn bot
def check_live_async(fb_link, user_id):
    status = "DIE"
    if check_live(fb_link):
        status = "LIVE"
    
    # Cập nhật trạng thái cho link đã lưu của người dùng
    for index, link_data in enumerate(data.get(user_id, [])):
        if link_data[0] == fb_link:
            data[user_id][index] = (fb_link, link_data[1], status)  # Cập nhật trạng thái
            save_data(data)  # Lưu lại vào file data.json
            if status == "LIVE":
                bot.send_message(user_id, f"🔴 {fb_link} đang LIVE!")
            return

# Lệnh /start - Lưu người dùng vào members.json với hạn sử dụng mặc định là 0
@bot.message_handler(commands=['start'])
def send_welcome(message):
    user_id = str(message.chat.id)
    members = load_members()

    if user_id not in members:
        members[user_id] = {"expire_date": "0"}  # Mặc định hạn sử dụng là 0
        save_members(members)

    bot.reply_to(message, """👋 Chào mừng bạn đến với bot của chúng tôi! 
    🔹 Chúng tôi là công cụ giúp các bạn trong việc dịch vụ Facebook, tricker...
    Bot sẽ hỗ trợ bạn nhận thông báo về trạng thái của các tài khoản Facebook mà bạn đang theo dõi (ví dụ: khi tài khoản đó "live").
    /menu - Hiển thị các tùy chọn lệnh bot
    /help - Hướng dẫn sử dụng bot
    /checktime - Kiểm tra hạn sử dụng
    /nangcap - Nâng cấp gói sử dụng bot""")

@bot.message_handler(commands=['nangcap'])
def upgrade_package(message):
    user_id = str(message.chat.id)
    
    # Nếu người dùng đã là thành viên, không cần nâng cấp
    if is_member(user_id):
        bot.reply_to(message, "⚠ Bạn đã là thành viên của bot rồi!")
        return
    
    # Tạo nội dung chuyển khoản và đường dẫn thanh toán
    payment_content = f"bkb{user_id}"
    payment_url = f"https://qrcode.io.vn/api/generate/MBBANK/9999992009/78000/{payment_content}"

    # Lấy ảnh QR từ URL
    response = requests.get(payment_url)
    
    if response.status_code == 200:
        qr_file_path = f'anh/{user_id}.png'

        # Lưu file ảnh QR vào ổ đĩa
        with open(qr_file_path, 'wb') as file:
            file.write(response.content)
        payment_content = f"bkb{user_id}"
        # Gửi thông tin về gói nâng cấp và hình ảnh QR Code
        bot.reply_to(message, f"""💡 Gói nâng cấp bot:
        - Giá gói: 78.000VND/1 tháng
        - Số tài khoản: 9999992009
        - Ngân hàng: MB Bank
        - Nội dung chuyển khoản: {payment_content}

        🖼 QR Code thanh toán:""")


        with open(qr_file_path, 'rb') as qr_file:
            bot.send_photo(message.chat.id, qr_file)  
        bot.reply_to(message, "Sau khi chuyển khoản thành công, bot sẽ tự động thêm bạn vào danh sách thành viên và bạn có thể sử dụng tất cả các tính năng của bot!")
    else:
        bot.reply_to(message, "⚠ Không thể tạo mã QR. Vui lòng thử lại sau!")
@bot.message_handler(commands=['checktime'])
def check_time(message):
    user_id = str(message.chat.id)
    members = load_members()
    expire_date = members.get(user_id, {}).get("expire_date", "0")

    if expire_date == "0":
        bot.reply_to(message, "⚠ Bạn chưa được kích hoạt gói sử dụng.")
    else:
        bot.reply_to(message, f"⏳ Gói của bạn có hạn đến: {expire_date}")

@bot.message_handler(commands=['addmem'])
def add_member(message):
    user_id = str(message.chat.id)
    if user_id != ADMIN_ID:
        bot.reply_to(message, "⚠ Bạn không có quyền sử dụng lệnh này.")
        return

    parts = message.text.split(" ")
    if len(parts) < 2:
        bot.reply_to(message, "⚠ Vui lòng nhập đúng cú pháp: /addmem <user_id>")
        return

    new_member_id = parts[1]
    members = load_members()

    if new_member_id not in members:
        members[new_member_id] = {"expire_date": "0"}

    current_date = datetime.now()
    new_expire_date = (current_date + timedelta(days=30)).strftime("%Y-%m-%d")

    members[new_member_id]["expire_date"] = new_expire_date
    save_members(members)
    bot.send_message(new_member_id, f"🎉 Bạn đã được thêm vào danh sách thành viên với hạn sử dụng đến: {new_expire_date}")

    bot.reply_to(message, f"✅ Đã thêm {new_member_id} vào danh sách thành viên với hạn sử dụng đến {new_expire_date}!")
@bot.message_handler(commands=['id'])
def send_id(message):
    user_id = str(message.chat.id)
    bot.reply_to(message, f"💡 ID của bạn là: {user_id}")

@bot.message_handler(commands=['listmem'])
def list_members(message):
    user_id = str(message.chat.id)
    if user_id != ADMIN_ID:
        bot.reply_to(message, "⚠ Bạn không có quyền sử dụng lệnh này.")
        return

    members = load_members()
    if members:
        member_list = "\n".join(f"{user} - Hết hạn: {info['expire_date']}" for user, info in members.items())
        bot.reply_to(message, f"📋 Danh sách thành viên:\n{member_list}")
    else:
        bot.reply_to(message, "⚠ Không có thành viên nào trong danh sách!")

@bot.message_handler(commands=['menu'])
def show_menu(message):
    bot.reply_to(message, """🔹 Danh sách các lệnh bot:
    1. /add <link_fb> <note> - Thêm link Facebook và ghi chú (nếu có).
    2. /rm <link_fb> - Xóa link Facebook đã lưu.
    3. /ds - Danh sách các link đã lưu.
    4. /nangcap - Nâng cấp gói sử dụng bot.
    5. /help - Hướng dẫn sử dụng bot.
    6. /checktime: Kiểm tra hạn sử dụng của gói.""")

@bot.message_handler(commands=['help'])
def show_help(message):
    bot.reply_to(message, """📖 Hướng dẫn sử dụng bot:
    - /add <link_fb> <note>: Thêm một link Facebook và ghi chú (nếu có). Bot sẽ kiểm tra trạng thái của link đó và cập nhật vào danh sách.
    - /rm <link_fb>: Xóa một link Facebook đã được lưu.
    - /ds: Hiển thị tất cả các link Facebook mà bạn đã thêm vào bot.
    - /nangcap: Nâng cấp gói sử dụng bot.
    - /checktime: Kiểm tra hạn sử dụng của gói.
    Hãy thử các lệnh trên và trải nghiệm bot!
    Admin hỗ trợ duy nhất: @bokepanel """)
# Xóa link Facebook
@bot.message_handler(commands=['rm'])
def remove_link(message):
    user_id = str(message.chat.id)
    if not is_member(user_id):
        bot.reply_to(message, "⚠ Bạn không có quyền sử dụng lệnh này.")
        return

    fb_link = message.text.split(" ", 1)[-1]
    if user_id in data:
        data[user_id] = [link for link in data[user_id] if link[0] != fb_link]
        save_data(data)
        bot.reply_to(message, f"🗑 Đã xóa link {fb_link}")
    else:
        bot.reply_to(message, "⚠ Link không tồn tại!")

@bot.message_handler(commands=['add'])
def add_link(message):
    user_id = str(message.chat.id)
    if not is_member(user_id):
        bot.reply_to(message, "⚠ Bạn không có quyền sử dụng lệnh này. Liên hệ với quản trị viên để được hỗ trợ.")
        return

    parts = message.text.split(" ", 2)

    if len(parts) < 2:
        bot.reply_to(message, "⚠ Lệnh không đúng định dạng! Vui lòng sử dụng /add <link_fb> <note>")
        return

    fb_link = parts[1]
    note = parts[2] if len(parts) > 2 else "Không có ghi chú"

    bot.reply_to(message, "🔄 Đang kiểm tra trạng thái link, vui lòng đợi...")

    if user_id not in data:
        data[user_id] = []

    link_exists = any(link[0] == fb_link for link in data[user_id])

    if not link_exists:
        data[user_id].append((fb_link, note, "DIE"))
        save_data(data)  # Lưu vào file data.json
        threading.Thread(target=check_live_async, args=(fb_link, user_id), daemon=True).start()
        bot.reply_to(message, f"✅ Đã thêm link {fb_link} với ghi chú: {note} và trạng thái: DIE")
    else:
        bot.reply_to(message, "⚠ Link đã tồn tại!")
# Danh sách link đã lưu
@bot.message_handler(commands=['ds'])
def list_links(message):
    user_id = str(message.chat.id)
    if not is_member(user_id):
        bot.reply_to(message, "⚠ Bạn không có quyền sử dụng lệnh này.")
        return

    if user_id in data and data[user_id]:
        response = "📌 *Danh sách link đã lưu:* \n"
        for fb_link, note, status in data[user_id]:
            response += f"🔗 {fb_link} - Trạng thái: {status} - Ghi chú: {note}\n"
        bot.reply_to(message, response, parse_mode="Markdown")
    else:
        bot.reply_to(message, "⚠ Bạn chưa thêm link nào!")

# Khởi chạy bot
bot.polling(none_stop=True)
